'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _get = require('babel-runtime/helpers/get')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _slicedToArray = require('babel-runtime/helpers/sliced-to-array')['default'];

var _extends = require('babel-runtime/helpers/extends')['default'];

var _Object$defineProperty = require('babel-runtime/core-js/object/define-property')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

_Object$defineProperty(exports, '__esModule', {
  value: true
});

exports['default'] = connect;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodashObjectPick = require('lodash/object/pick');

var _lodashObjectPick2 = _interopRequireDefault(_lodashObjectPick);

var _lodashUtilityIdentity = require('lodash/utility/identity');

var _lodashUtilityIdentity2 = _interopRequireDefault(_lodashUtilityIdentity);

var contextTypes = {
  observeStores: _react.PropTypes.func.isRequired
};

function connect() {
  for (var _len = arguments.length, storeKeys = Array(_len), _key = 0; _key < _len; _key++) {
    storeKeys[_key] = arguments[_key];
  }

  var mapState = _lodashUtilityIdentity2['default'];

  // Last argument may be a custom mapState function
  var lastIndex = storeKeys.length - 1;
  if (typeof storeKeys[lastIndex] === 'function') {
    var _storeKeys$splice = storeKeys.splice(lastIndex, 1);

    var _storeKeys$splice2 = _slicedToArray(_storeKeys$splice, 1);

    mapState = _storeKeys$splice2[0];
  }

  return function (DecoratedComponent) {
    var wrappedDisplayName = DecoratedComponent.displayName || DecoratedComponent.name || 'Component';

    return (function (_Component) {
      var _class = function (props, context) {
        _classCallCheck(this, _class);

        _get(Object.getPrototypeOf(_class.prototype), 'constructor', this).call(this, props, context);
        this.handleChange = this.handleChange.bind(this);
        this.unobserve = this.context.observeStores(storeKeys, this.handleChange);
      };

      _inherits(_class, _Component);

      _createClass(_class, [{
        key: 'handleChange',
        value: function handleChange(stateFromStores) {
          this.currentStateFromStores = (0, _lodashObjectPick2['default'])(stateFromStores, storeKeys);
          this.updateState(stateFromStores, this.props);
        }
      }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
          this.updateState(this.currentStateFromStores, nextProps);
        }
      }, {
        key: 'updateState',
        value: function updateState(stateFromStores, props) {
          if (storeKeys.length === 1) {
            // Just give it the particular store state for convenience
            stateFromStores = stateFromStores[storeKeys[0]];
          }

          var state = mapState(stateFromStores, props);
          if (this.state) {
            this.setState(state);
          } else {
            this.state = state;
          }
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          this.unobserve();
        }
      }, {
        key: 'render',
        value: function render() {
          return _react2['default'].createElement(DecoratedComponent, _extends({}, this.props, this.state));
        }
      }], [{
        key: 'displayName',
        value: 'ReduxObserves(' + wrappedDisplayName + ')',
        enumerable: true
      }, {
        key: 'contextTypes',
        value: contextTypes,
        enumerable: true
      }]);

      return _class;
    })(_react.Component);
  };
}

module.exports = exports['default'];